//+------------------------------------------------------------------+
//|                                                    RsiOma_Db.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window


sinput string _Comment_1 = "Preamble must be unique for evere instance in chart";
sinput string objectPreamble = "AA_Stoch_821_db_";
sinput string _symbol = "EURUSD";
sinput int UpdateTimerInSeconds = 5;
sinput long chartId = 0;
sinput bool showMonth = true;
sinput bool showWeek = true;
sinput bool showDay = true;
sinput bool showH4 = true;
sinput bool showH1 = true;
sinput bool showM30 = false;
sinput bool showM15 = true;
sinput bool showM5 = true;
sinput bool showM1 = false;

input int stoch_1_kPeriod = 8;
input int stoch_1_dPeriod = 3;
input int stoch_1_Slowing = 3;

input int stoch_2_kPeriod = 21;
input int stoch_2_dPeriod = 10;
input int stoch_2_Slowing = 10;

sinput int maMethod_1 = 0;
sinput int priceField_1 = 1;

sinput int xAnchor = 20;
sinput int yAnchor = 50;
sinput int fontSize = 6;
sinput int squareSize = 20;
sinput int squareSpace = 5;

sinput color textColor = clrOrange;
sinput int xOutline = 3;
sinput int arrowOutlineX = 3;
sinput int arrowOutlineY = 3;
double multiplier = 1.65;

int yOffsetArrow;

string preamble ;


double tmpValue_1, tmpValue_2, tmpValue_3, tmpValue_4;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   string name, s;
   s = preamble;
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
   EventSetTimer(UpdateTimerInSeconds);
   yOffsetArrow = arrowOutlineY;
   
   preamble = _symbol + "_" + objectPreamble;
   return(INIT_SUCCEEDED);
  }
  
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
   // delete objects
    string name;
    string s = preamble;
 
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
      
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   // calculate the rsioma values for all selected timeframes
   
   int xOffset = xAnchor;
   int yOffset = yAnchor;
   int squareOffset = 15;
   string strNumber;
   double diff;
   
   SetText(chartId, preamble + "Pair_" + _symbol,_symbol, xOffset, yOffset-20, textColor, fontSize + 5);

   
   if (showMonth)
   {

      tmpValue_1 = iStochastic(_symbol, PERIOD_MN1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, MODE_SMA, 1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_MN1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, MODE_SMA, 1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_MN1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, MODE_SMA, 1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_MN1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, MODE_SMA, 1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "MN1_label_" + _symbol,"MN", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_MN1_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_MN1_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_MN1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_MN1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_MN1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_MN1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_MN1_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_MN1_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   if (showWeek)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_W1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_W1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_W1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_W1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "W1_label_" + _symbol,"W1", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_W1_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_W1_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_W1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_W1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_W1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_W1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_W1_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_W1_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }

   if (showDay)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_D1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_D1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_D1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_D1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "D1_label_" + _symbol,"D1", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_D1_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_D1_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_D1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_D1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_D1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_D1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_D1_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_D1_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }   

   if (showH4)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_H4,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_H4,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_H4,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_H4,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "H4_label_" + _symbol,"H4", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_H4_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_H4_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_H4_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_H4_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_H4_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_H4_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_H4_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_H4_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }   

   if (showH1)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_H1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_H1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_H1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_H1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "H1_label_" + _symbol,"H1", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_H1_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_H1_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_H1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_H1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_H1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_H1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_H1_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_H1_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }

   if (showM30)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_M30,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_M30,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_M30,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_M30,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "M30_label_" + _symbol,"M30", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_M30_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_M30_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_M30_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_M30_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_M30_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_M30_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_M30_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_M30_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }

   if (showM15)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_M15,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_M15,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_M15,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_M15,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "M15_label_" + _symbol,"M15", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_M15_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_M15_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_M15_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_M15_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_M15_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_M15_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_M15_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_M15_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   if (showM5)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_M5,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_M5,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_M5,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_M5,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "M5_label_" + _symbol,"M5", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_M5_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_M5_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_M5_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_M5_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_M5_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_M5_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_M5_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_M5_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   if (showM1)
   {
      tmpValue_1 = iStochastic(_symbol, PERIOD_M1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(_symbol, PERIOD_M1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_3 = iStochastic(_symbol, PERIOD_M1,stoch_1_kPeriod,stoch_1_dPeriod, stoch_1_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      tmpValue_4 = iStochastic(_symbol, PERIOD_M1,stoch_2_kPeriod,stoch_2_dPeriod, stoch_2_Slowing, maMethod_1, priceField_1,MODE_MAIN,1);
      
      SetText(chartId, preamble + "M1_label_" + _symbol,"M1", xOffset, yOffset, textColor,fontSize);
      if (tmpValue_1 > tmpValue_3 )
      {
         SetObjText(chartId, preamble + "arrow_M1_1_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_1 < tmpValue_3)
      {
         SetObjText(chartId, preamble + "arrow_M1_1_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 8, clrRed,fontSize+3);
      }
      diff = tmpValue_1 - tmpValue_2;
      strNumber = IntegerToString((int)diff,2);
      if (diff > 0)
      {
         SetObjText(chartId, preamble + "square_M1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrLime,squareSize);
         SetText(chartId, preamble + "_diff_M1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      else
      {
         SetObjText(chartId, preamble + "square_M1_" + _symbol,CharToStr(110), xOffset-xOutline, yOffset + squareOffset + fontSize + 4, clrRed,squareSize);
         SetText(chartId, preamble + "_diff_M1_", strNumber, xOffset-xOutline + 5, yOffset + squareOffset + fontSize + 15, clrBlack, fontSize);
      }
      if (tmpValue_2 > tmpValue_4 )
      {
         SetObjText(chartId, preamble + "arrow_M1_2_" + _symbol,CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 6, clrLime,fontSize + 3);
      }
      else if (tmpValue_2 < tmpValue_4)
      {
         SetObjText(chartId, preamble + "arrow_M1_2_" + _symbol,CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + 3*squareOffset + 8, clrRed,fontSize+3);
      }
   }
   
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+


void SetObjText(long chart_id, string name,string CharToStr,int x,int y,color colour,int fontsize=12)
  {
   if(ObjectFind(0,name)<0)
      ObjectCreate(0, name, OBJ_LABEL,chart_id, 0, 0);

   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
  }
  
  void SetText(long chart_id, string name,string text,int x,int y,color colour,int fontsize)
  {
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,chart_id,0,0);

    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_FONT,"Arial");
    ObjectSetString(0,name,OBJPROP_TEXT,text);
  }