//+------------------------------------------------------------------+
//|                                               Alien stoch db.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window



sinput string _Comment_2 = "Preamble must be unique for evere instance in chart";
sinput string objectpreamble = "a_stoch_db_";
sinput int UpdateTimerInSeconds = 5;
sinput long chartId = 0;
//sinput bool showMonth = false;
sinput bool showWeek = true;
sinput bool showDay = true;
sinput bool showH4 = true;
sinput bool showH1 = true;
sinput bool showM30 = false;
sinput bool showM15 = true;
sinput bool showM5 = true;
sinput bool showM1 = true;

sinput bool show_stoch_1 = true;
sinput int kPeriod_1 = 8;
sinput int Slowing_1 = 3;
sinput int dPeriod_1 = 3;
sinput int maMethod_1 = 0;
sinput int priceField_1 = 1;
/*
sinput bool show_stoch_2 = true;
sinput int kPeriod_2 = 21;
sinput int Slowing_2 = 10;
sinput int dPeriod_2 = 10;
sinput int maMethod_2 = 0;
sinput int priceField_2 = 1;

sinput bool show_stoch_3 = true;
sinput int kPeriod_3 = 100;
sinput int Slowing_3 = 10;
sinput int dPeriod_3 = 10;
sinput int maMethod_3 = 0;
sinput int priceField_3 = 1;
*/
bool show_stoch_2 = false;
bool show_stoch_3 = false;

sinput int xAnchor = 1250;
sinput int yAnchor = 10;
sinput int fontSizeText = 6;
sinput int squareSize = 14;
sinput int squareSpace = 5;
sinput int textOffsetY = 4;

sinput color textColor = clrWhite;
sinput color dbBackgroundColor = clrBlack;
sinput color dbBorderColor = clrGainsboro;
sinput int dbBorderWidth = 1;

sinput color bullColor = clrLime;
sinput color bearColor = clrRed;

double stochUpperlevel = 80.0;
double stochLowerlevel = 20.0;
double stochMiddellevel = 50.0;



int yOffsetArrow;

string preamble ;
int panelWidth;
int panelHeight;


double tmpValue_1, tmpValue_2, tmpValue_3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   preamble = objectpreamble;
   string name, s;
   s = objectpreamble;
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
   EventSetTimer(UpdateTimerInSeconds);

   if (!show_stoch_1 && !show_stoch_2 && !show_stoch_3)
   {
      Alert("No stoch selected");
      return(INIT_FAILED);
   }
   panelWidth = fontSizeText * 3;
   if (show_stoch_1) {panelWidth = panelWidth + squareSize * 4 + squareSpace * 5;}
   if (show_stoch_2) {panelWidth = panelWidth + squareSize * 3 + squareSpace * 4;}
   if (show_stoch_3) {panelWidth = panelWidth + squareSize * 3 + squareSpace * 4;}
   int counter = 0;
   panelHeight = squareSize + squareSpace;
   
   if (showM1) {counter++;}
   if (showM5) {counter++;}
   if (showM15) {counter++;}
   if (showM30) {counter++;}
   if (showH1) {counter++;}
   if (showH4) {counter++;}
   if (showDay) {counter++;}
   if (showWeek) {counter++;}
   
   if (counter == 0)
   {
      Alert("No TF selected");
      return(INIT_FAILED);
   }
   panelHeight = (counter + 2) * squareSize + (counter + 3) * squareSpace;
   return(INIT_SUCCEEDED);
  }
  
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
   // delete objects
    string name;
    string s = preamble;
 
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
      
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   // calculate the rsioma values for all selected timeframes
   
   int xOffset = xAnchor;
   int yOffset = yAnchor;
   int stochOffset = 25;
   int _squareSize = squareSize - 2;
   
   //first display panel
   
   // headers
   SetPanel(preamble + "panel_",chartId,xOffset, yOffset, panelWidth, panelHeight,dbBackgroundColor,dbBorderColor,dbBorderWidth);
   
   if (show_stoch_1)
   {
      SetText(chartId, preamble + "header_1", "STOCH DB", xOffset + stochOffset, yOffset + fontSizeText, textColor, fontSizeText);
      yOffset = yOffset + squareSize;
      SetText(chartId, preamble + "header_1_20", "20", xOffset + stochOffset, yOffset + fontSizeText, textColor, fontSizeText);
      SetText(chartId, preamble + "header_1_50", "50", xOffset + stochOffset + squareSize + squareSpace, yOffset + fontSizeText, textColor, fontSizeText);
      SetText(chartId, preamble + "header_1_80", "80", xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset + fontSizeText, textColor, fontSizeText);
   }
  
   
   if (showM1)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_M1_1", "M1", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_M1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_M1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_M1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_M1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_M1_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_M1_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      
      //yOffset = yOffset + squareSize + squareSpace;
   
   }
   
   if (showM5)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_M5_1", "M5", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_M5,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_M5,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_M5_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M5_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_M5_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M5_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M5_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_M5_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_M5_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
   
   if (showM15)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_M15_1", "M15", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_M15,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_M15,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_M15_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M15_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_M15_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M15_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M15_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_M15_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_M15_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
   
   if (showM30)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_M30_1", "M30", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_M30,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_M30,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_M30_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M30_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_M30_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_M30_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_M30_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_M30_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_M30_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
   
   if (showH1)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_H1_1", "H1", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_H1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_H1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_H1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_H1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_H1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_H1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_H1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_H1_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_H1_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
   
   if (showH4)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_H4_1", "H4", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_H4,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_H4,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_H4_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_H4_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_H4_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_H4_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_H4_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_H4_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_H4_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
   
   if (showDay)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_D1_1", "D1", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_D1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_D1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_D1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_D1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_D1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_D1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_D1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_D1_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_D1_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
   
   if (showWeek)
   {
      // write TF
      yOffset = yOffset + squareSize + squareSpace;
      SetText(chartId,preamble + "labelText_W1_1", "W1", xAnchor + squareSpace,yOffset + textOffsetY,textColor,fontSizeText);
      tmpValue_1 = iStochastic(Symbol(), PERIOD_W1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,0);
      tmpValue_2 = iStochastic(Symbol(), PERIOD_W1,kPeriod_1,dPeriod_1, Slowing_1, maMethod_1, priceField_1,MODE_MAIN,1);
      
      if (tmpValue_1 > stochUpperlevel)
      {
         SetObjText(chartId,preamble + "label_W1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_W1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_W1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , bullColor, _squareSize);
      }
      else if (tmpValue_1 > stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_W1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_W1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bullColor, _squareSize);
         SetObjText(chartId,preamble + "label_W1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      }
      else if (tmpValue_1 < stochLowerlevel)
      {
         SetObjText(chartId,preamble + "label_W1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_W1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_w1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      else if (tmpValue_1 < stochMiddellevel)
      {
         SetObjText(chartId,preamble + "label_W1_St1_20",CharToStr(110), xOffset + stochOffset, yOffset, dbBackgroundColor, _squareSize);
         SetObjText(chartId,preamble + "label_W1_St1_50",CharToStr(110), xOffset + stochOffset + squareSize + squareSpace, yOffset , bearColor, _squareSize);
         SetObjText(chartId,preamble + "label_w1_St1_80",CharToStr(110), xOffset + stochOffset + 2*squareSize + 2*squareSpace, yOffset , dbBackgroundColor, _squareSize);
      
      }
      if (tmpValue_1 > tmpValue_2)
      {
         SetObjText(chartId,preamble + "Label_W1_st1_Arrow", CharToStr(233),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 4,bullColor,fontSizeText);
      }
      else
      {
         SetObjText(chartId,preamble + "Label_W1_st1_Arrow", CharToStr(234),xOffset + stochOffset + 3*squareSize + 3*squareSpace,yOffset + 7,bearColor,fontSizeText);
      }
      //yOffset = yOffset + squareSize + squareSpace;
   }
  
    
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+


void SetObjText(long chart_id, string name,string CharToStr,int x,int y,color colour,int fontsize=12)
  {
   if(ObjectFind(0,name)<0)
      ObjectCreate(0, name, OBJ_LABEL,chart_id, 0, 0);

   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
  }
  
  void SetText(long chart_id, string name,string text,int x,int y,color colour,int fontsize)
  {
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,chart_id,0,0);

    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_FONT,"Arial");
    ObjectSetString(0,name,OBJPROP_TEXT,text);
  }
  
void SetPanel(string name,int chart_id,int x,int y,int width,int height,color bg_color,color border_clr,int border_width)
  {
   
   if (ObjectFind(0, name) < 0) ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,chart_id,0,0);
   

      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_BACK,true);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,0);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
  }