//+------------------------------------------------------------------+
//|                                                    RsiOma_Db.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window


sinput string _Comment = "RSIOMA (2).ex4 is needed";
sinput string _Comment_2 = "Preamble must be unique for evere instance in chart";
sinput string objectpreamble = "rsioma_db_";
sinput int UpdateTimerInSeconds = 5;
sinput long chartId = 0;
sinput bool showMonth = false;
sinput bool showWeek = true;
sinput bool showDay = true;
sinput bool showH4 = true;
sinput bool showH1 = true;
sinput bool showM30 = false;
sinput bool showM15 = true;
sinput bool showM5 = true;
sinput bool showM1 = false;

sinput bool useSignalsRank = false;

sinput int xAnchor = 1250;
sinput int yAnchor = 200;
sinput int fontSize = 6;
sinput int squareSize = 14;
sinput int squareSpace = 5;

sinput color textColor = clrOrange;
sinput int xOutline = 3;
sinput int arrowOutlineX = 3;
sinput int arrowOutlineY = 3;
double multiplier = 1.65;

int yOffsetArrow;

string preamble ;


double tmpValue_1, tmpValue_2, tmpValue_3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   string name, s;
   s = preamble;
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
   EventSetTimer(UpdateTimerInSeconds);
   yOffsetArrow = arrowOutlineY;
   
   preamble = objectpreamble;
   return(INIT_SUCCEEDED);
  }
  
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
   // delete objects
    string name;
    string s = preamble;
 
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
    }
      
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   // calculate the rsioma values for all selected timeframes
   
   int xOffset = xAnchor;
   int yOffset = yAnchor;
   if (showMonth)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_MN1,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_MN1,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_MN1,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "MN1_label_" + Symbol(),"M", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_MN1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_MN1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_MN1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_MN1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_MN1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MN1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   if (showWeek)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_W1,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_W1,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_W1,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "W1_label_" + Symbol(),"W", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_W1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_W1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_W1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_W1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_W1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_W1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }      
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }

   //////////////
   if (showDay)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_D1,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_D1,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_D1,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "D1_label_" + Symbol(),"D", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_D1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_D1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_D1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_D1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_D1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_D1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   ///////////////
   if (showH4)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_H4,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_H4,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_H4,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "H4_label_" + Symbol(),"H4", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_H4_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_H4_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_H4_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_H4_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_H4_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H4_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }
   /////////////////
   if (showH1)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_H1,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_H1,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_H1,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "H1_label_" + Symbol(),"H1", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_H1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_H1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_H1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_H1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_H1_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_H1_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_MH_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   
   if (showM30)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_M30,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_M30,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_M30,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "M30_label_" + Symbol(),"30", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_M30_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_M30_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_M30_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_M30_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_M30_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M30_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }
   
   ///////////////
   if (showM15)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_M15,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_M15,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_M15,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "M15_label_" + Symbol(),"15", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_M15_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_M15_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_M15_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_M15_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_M15_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
      }
      
      xOffset = xOffset + squareSize + squareSpace;
   }
   ///////////////
   if (showM15)
   {
      tmpValue_1 = iCustom(Symbol(),PERIOD_M5,"RSIOMA (2)", 0, 0);
      tmpValue_2 = iCustom(Symbol(),PERIOD_M5,"RSIOMA (2)", 5, 0);
      tmpValue_3 = iCustom(Symbol(),PERIOD_M5,"RSIOMA (2)", 0, 1);
      
      SetText(chartId, preamble + "M5_label_" + Symbol(),"5", xOffset, yOffset, textColor,fontSize);
      if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 80.0)
      {
         SetObjText(chartId, preamble + "square_M5_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrLime,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 > tmpValue_2 || !useSignalsRank) && tmpValue_1 > 50.0)
      {
         SetObjText(chartId, preamble + "square_M5_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGreen,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M15_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 20.0)
      {
         SetObjText(chartId, preamble + "square_M5_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrRed,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else if ((tmpValue_1 < tmpValue_2 || !useSignalsRank) && tmpValue_1 < 50.0)
      {
         SetObjText(chartId, preamble + "square_M5_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrOrange,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
         else
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(243), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier, clrOrange,fontSize);
         }
      }
      else
      {
         SetObjText(chartId, preamble + "square_M5_" + Symbol(),CharToStr(110), xOffset-xOutline, yOffset + fontSize + 4, clrGray,squareSize);
         if (tmpValue_1 > tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(233), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier , clrLime,fontSize);
         }
         else if (tmpValue_1 < tmpValue_3)
         {
            SetObjText(chartId, preamble + "arrow_M5_" + Symbol(),CharToStr(234), xOffset + arrowOutlineX, yOffset + fontSize + squareSize * multiplier + yOffsetArrow, clrRed,fontSize);
         }
      }
      
      //xOffset = xOffset + squareSize + 2;
   }
   
   SetText(chartId, preamble + "Title_" + Symbol(),"RsiOma DB", xAnchor, yOffset + 50, textColor, fontSize * 1.5);
   
   
    
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+


void SetObjText(long chart_id, string name,string CharToStr,int x,int y,color colour,int fontsize=12)
  {
   if(ObjectFind(0,name)<0)
      ObjectCreate(0, name, OBJ_LABEL,chart_id, 0, 0);

   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
  }
  
  void SetText(long chart_id, string name,string text,int x,int y,color colour,int fontsize)
  {
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,chart_id,0,0);

    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_FONT,"Arial");
    ObjectSetString(0,name,OBJPROP_TEXT,text);
  }